*** linux-2.0.28/Makefile	Tue Jan 14 04:21:28 1997
--- KERNEL/Makefile	Fri Aug  8 16:15:05 1997
***************
*** 210,219 ****
  	fi
  
  include/linux/compile.h: $(CONFIGURATION) include/linux/version.h newversion
! 	@if [ -f .name ]; then \
! 	   echo \#define UTS_VERSION \"\#`cat .version`-`cat .name` `date`\"; \
  	 else \
! 	   echo \#define UTS_VERSION \"\#`cat .version` `date`\";  \
  	 fi >> .ver
  	@echo \#define LINUX_COMPILE_TIME \"`date +%T`\" >> .ver
  	@echo \#define LINUX_COMPILE_BY \"`whoami`\" >> .ver
--- 210,221 ----
  	fi
  
  include/linux/compile.h: $(CONFIGURATION) include/linux/version.h newversion
! 	@if [ -f VERSION ]; then \
! 	     echo \#define UTS_VERSION \"\#`cat VERSION` `date`\"; \
! 	 elif [ -f .name ]; then \
! 	     echo \#define UTS_VERSION \"\#`cat .version`-`cat .name` `date`\";\
  	 else \
! 	     echo \#define UTS_VERSION \"\#`cat .version` `date`\";  \
  	 fi >> .ver
  	@echo \#define LINUX_COMPILE_TIME \"`date +%T`\" >> .ver
  	@echo \#define LINUX_COMPILE_BY \"`whoami`\" >> .ver
***************
*** 267,272 ****
--- 269,275 ----
  endif
  
  modules: include/linux/version.h
+ 	@-mkdir modules
  	@set -e; \
  	for i in $(SUBDIRS); \
  	do $(MAKE) -C $$i CFLAGS="$(CFLAGS) $(MODFLAGS)" MAKING_MODULES=1 modules; \
***************
*** 313,319 ****
  	rm -f core `find . -type f -name 'core' -print`
  	rm -f vmlinux System.map
  	rm -f .tmp* drivers/sound/configure
! 	rm -fr modules/*
  	rm -f submenu*
  
  mrproper: clean
--- 316,322 ----
  	rm -f core `find . -type f -name 'core' -print`
  	rm -f vmlinux System.map
  	rm -f .tmp* drivers/sound/configure
! 	rm -fr modules
  	rm -f submenu*
  
  mrproper: clean
*** linux-2.0.28/arch/i386/kernel/bios32.c	Sat Jun  8 01:10:49 1996
--- KERNEL/arch/i386/kernel/bios32.c	Thu Jul 31 12:03:22 1997
***************
*** 56,61 ****
--- 56,62 ----
  #include <linux/pci.h>
  
  #include <asm/segment.h>
+ #include <asm/io.h>
  
  #define PCIBIOS_PCI_FUNCTION_ID 	0xb1XX
  #define PCIBIOS_PCI_BIOS_PRESENT 	0xb101
***************
*** 110,452 ****
  
  static unsigned long bios32_entry = 0;
  static struct {
! 	unsigned long address;
! 	unsigned short segment;
! } bios32_indirect = { 0, KERNEL_CS };
  
  #ifdef CONFIG_PCI
  /*
   * Returns the entry point for the given service, NULL on error
   */
  
  static unsigned long bios32_service(unsigned long service)
  {
! 	unsigned char return_code;	/* %al */
! 	unsigned long address;		/* %ebx */
! 	unsigned long length;		/* %ecx */
! 	unsigned long entry;		/* %edx */
! 
! 	__asm__("lcall (%%edi)"
! 		: "=a" (return_code),
! 		  "=b" (address),
! 		  "=c" (length),
! 		  "=d" (entry)
! 		: "0" (service),
! 		  "1" (0),
! 		  "D" (&bios32_indirect));
! 
! 	switch (return_code) {
! 		case 0:
! 			return address + entry;
! 		case 0x80:	/* Not present */
! 			printk("bios32_service(%ld) : not present\n", service);
! 			return 0;
! 		default: /* Shouldn't happen */
! 			printk("bios32_service(%ld) : returned 0x%x, mail drew@colorado.edu\n",
! 				service, return_code);
! 			return 0;
! 	}
  }
  
  static long pcibios_entry = 0;
  static struct {
! 	unsigned long address;
! 	unsigned short segment;
! } pci_indirect = { 0, KERNEL_CS };
  
  
  extern unsigned long check_pcibios(unsigned long memory_start, unsigned long memory_end)
  {
! 	unsigned long signature;
! 	unsigned char present_status;
! 	unsigned char major_revision;
! 	unsigned char minor_revision;
! 	int pack;
! 
! 	if ((pcibios_entry = bios32_service(PCI_SERVICE))) {
! 		pci_indirect.address = pcibios_entry;
! 
! 		__asm__("lcall (%%edi)\n\t"
! 			"jc 1f\n\t"
! 			"xor %%ah, %%ah\n"
! 			"1:\tshl $8, %%eax\n\t"
! 			"movw %%bx, %%ax"
! 			: "=d" (signature),
! 			  "=a" (pack)
! 			: "1" (PCIBIOS_PCI_BIOS_PRESENT),
! 			  "D" (&pci_indirect)
! 			: "bx", "cx");
! 
! 		present_status = (pack >> 16) & 0xff;
! 		major_revision = (pack >> 8) & 0xff;
! 		minor_revision = pack & 0xff;
! 		if (present_status || (signature != PCI_SIGNATURE)) {
! 			printk ("pcibios_init : %s : BIOS32 Service Directory says PCI BIOS is present,\n"
! 				"	but PCI_BIOS_PRESENT subfunction fails with present status of 0x%x\n"
! 				"	and signature of 0x%08lx (%c%c%c%c).  mail drew@Colorado.EDU\n",
! 				(signature == PCI_SIGNATURE) ?  "WARNING" : "ERROR",
! 				present_status, signature,
! 				(char) (signature >>  0), (char) (signature >>  8),
! 				(char) (signature >> 16), (char) (signature >> 24));
! 
! 			if (signature != PCI_SIGNATURE)
! 				pcibios_entry = 0;
! 		}
! 		if (pcibios_entry) {
! 			printk ("pcibios_init : PCI BIOS revision %x.%02x entry at 0x%lx\n",
! 				major_revision, minor_revision, pcibios_entry);
! 		}
  	}
! 	return memory_start;
  }
  
! int pcibios_present(void)
  {
! 	return pcibios_entry ? 1 : 0;
  }
  
! int pcibios_find_class (unsigned int class_code, unsigned short index,
! 	unsigned char *bus, unsigned char *device_fn)
  {
! 	unsigned long bx;
! 	unsigned long ret;
  
! 	__asm__ ("lcall (%%edi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=b" (bx),
! 		  "=a" (ret)
! 		: "1" (PCIBIOS_FIND_PCI_CLASS_CODE),
! 		  "c" (class_code),
! 		  "S" ((int) index),
! 		  "D" (&pci_indirect));
! 	*bus = (bx >> 8) & 0xff;
! 	*device_fn = bx & 0xff;
! 	return (int) (ret & 0xff00) >> 8;
  }
  
  
! int pcibios_find_device (unsigned short vendor, unsigned short device_id,
! 	unsigned short index, unsigned char *bus, unsigned char *device_fn)
  {
! 	unsigned short bx;
! 	unsigned short ret;
  
! 	__asm__("lcall (%%edi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=b" (bx),
! 		  "=a" (ret)
! 		: "1" (PCIBIOS_FIND_PCI_DEVICE),
! 		  "c" (device_id),
! 		  "d" (vendor),
! 		  "S" ((int) index),
! 		  "D" (&pci_indirect));
! 	*bus = (bx >> 8) & 0xff;
! 	*device_fn = bx & 0xff;
! 	return (int) (ret & 0xff00) >> 8;
  }
  
  int pcibios_read_config_byte(unsigned char bus,
! 	unsigned char device_fn, unsigned char where, unsigned char *value)
  {
! 	unsigned long ret;
! 	unsigned long bx = (bus << 8) | device_fn;
  
! 	__asm__("lcall (%%esi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=c" (*value),
! 		  "=a" (ret)
! 		: "1" (PCIBIOS_READ_CONFIG_BYTE),
! 		  "b" (bx),
! 		  "D" ((long) where),
! 		  "S" (&pci_indirect));
! 	return (int) (ret & 0xff00) >> 8;
  }
  
! int pcibios_read_config_word (unsigned char bus,
! 	unsigned char device_fn, unsigned char where, unsigned short *value)
  {
! 	unsigned long ret;
! 	unsigned long bx = (bus << 8) | device_fn;
  
! 	__asm__("lcall (%%esi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=c" (*value),
! 		  "=a" (ret)
! 		: "1" (PCIBIOS_READ_CONFIG_WORD),
! 		  "b" (bx),
! 		  "D" ((long) where),
! 		  "S" (&pci_indirect));
! 	return (int) (ret & 0xff00) >> 8;
  }
  
! int pcibios_read_config_dword (unsigned char bus,
! 	unsigned char device_fn, unsigned char where, unsigned int *value)
  {
! 	unsigned long ret;
! 	unsigned long bx = (bus << 8) | device_fn;
  
! 	__asm__("lcall (%%esi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=c" (*value),
! 		  "=a" (ret)
! 		: "1" (PCIBIOS_READ_CONFIG_DWORD),
! 		  "b" (bx),
! 		  "D" ((long) where),
! 		  "S" (&pci_indirect));
! 	return (int) (ret & 0xff00) >> 8;
  }
  
! int pcibios_write_config_byte (unsigned char bus,
! 	unsigned char device_fn, unsigned char where, unsigned char value)
  {
! 	unsigned long ret;
! 	unsigned long bx = (bus << 8) | device_fn;
  
! 	__asm__("lcall (%%esi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=a" (ret)
! 		: "0" (PCIBIOS_WRITE_CONFIG_BYTE),
! 		  "c" (value),
! 		  "b" (bx),
! 		  "D" ((long) where),
! 		  "S" (&pci_indirect));
! 	return (int) (ret & 0xff00) >> 8;
  }
  
! int pcibios_write_config_word (unsigned char bus,
! 	unsigned char device_fn, unsigned char where, unsigned short value)
  {
! 	unsigned long ret;
! 	unsigned long bx = (bus << 8) | device_fn;
  
! 	__asm__("lcall (%%esi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=a" (ret)
! 		: "0" (PCIBIOS_WRITE_CONFIG_WORD),
! 		  "c" (value),
! 		  "b" (bx),
! 		  "D" ((long) where),
! 		  "S" (&pci_indirect));
! 	return (int) (ret & 0xff00) >> 8;
  }
  
! int pcibios_write_config_dword (unsigned char bus,
  	unsigned char device_fn, unsigned char where, unsigned int value)
  {
! 	unsigned long ret;
! 	unsigned long bx = (bus << 8) | device_fn;
  
! 	__asm__("lcall (%%esi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:"
! 		: "=a" (ret)
! 		: "0" (PCIBIOS_WRITE_CONFIG_DWORD),
! 		  "c" (value),
! 		  "b" (bx),
! 		  "D" ((long) where),
! 		  "S" (&pci_indirect));
! 	return (int) (ret & 0xff00) >> 8;
  }
  
! const char *pcibios_strerror (int error)
  {
! 	static char buf[80];
  
! 	switch (error) {
! 		case PCIBIOS_SUCCESSFUL:
! 			return "SUCCESSFUL";
  
! 		case PCIBIOS_FUNC_NOT_SUPPORTED:
! 			return "FUNC_NOT_SUPPORTED";
  
! 		case PCIBIOS_BAD_VENDOR_ID:
! 			return "SUCCESSFUL";
  
! 		case PCIBIOS_DEVICE_NOT_FOUND:
! 			return "DEVICE_NOT_FOUND";
  
! 		case PCIBIOS_BAD_REGISTER_NUMBER:
! 			return "BAD_REGISTER_NUMBER";
  
!                 case PCIBIOS_SET_FAILED:          
! 			return "SET_FAILED";
  
!                 case PCIBIOS_BUFFER_TOO_SMALL:    
! 			return "BUFFER_TOO_SMALL";
  
! 		default:
! 			sprintf (buf, "UNKNOWN RETURN 0x%x", error);
! 			return buf;
! 	}
  }
  
  
  unsigned long pcibios_fixup(unsigned long mem_start, unsigned long mem_end)
  {
! return mem_start;
  }
  
  
- #endif
- 
  unsigned long pcibios_init(unsigned long memory_start, unsigned long memory_end)
  {
! 	union bios32 *check;
! 	unsigned char sum;
! 	int i, length;
! 
! 	/*
! 	 * Follow the standard procedure for locating the BIOS32 Service
! 	 * directory by scanning the permissible address range from
! 	 * 0xe0000 through 0xfffff for a valid BIOS32 structure.
! 	 *
! 	 */
! 
! 	for (check = (union bios32 *) 0xe0000; check <= (union bios32 *) 0xffff0; ++check) {
! 		if (check->fields.signature != BIOS32_SIGNATURE)
! 			continue;
! 		length = check->fields.length * 16;
! 		if (!length)
! 			continue;
! 		sum = 0;
! 		for (i = 0; i < length ; ++i)
! 			sum += check->chars[i];
! 		if (sum != 0)
! 			continue;
! 		if (check->fields.revision != 0) {
! 			printk("pcibios_init : unsupported revision %d at 0x%p, mail drew@colorado.edu\n",
! 				check->fields.revision, check);
! 			continue;
! 		}
! 		printk ("pcibios_init : BIOS32 Service Directory structure at 0x%p\n", check);
! 		if (!bios32_entry) {
! 			if (check->fields.entry >= 0x100000) {
! 				printk("pcibios_init: entry in high memory, unable to access\n");
! 			} else {
! 				bios32_indirect.address = bios32_entry = check->fields.entry;
! 				printk ("pcibios_init : BIOS32 Service Directory entry at 0x%lx\n", bios32_entry);
! 			}
! 		}
  	}
! #ifdef CONFIG_PCI
! 	if (bios32_entry) {
! 		memory_start = check_pcibios (memory_start, memory_end);
  	}
  #endif
! 	return memory_start;
  }
--- 111,833 ----
  
  static unsigned long bios32_entry = 0;
  static struct {
!     unsigned long address;
!     unsigned short segment;
! } bios32_indirect = {
!     0, KERNEL_CS
! };
  
  #ifdef CONFIG_PCI
+ 
+ /*
+  * function table for accessing PCI configuration space
+  */
+ struct pci_access {
+     int (*find_device) (unsigned short, unsigned short, unsigned short, unsigned char *, unsigned char *);
+     int (*find_class) (unsigned int, unsigned short, unsigned char *, unsigned char *);
+     int (*read_config_byte) (unsigned char, unsigned char, unsigned char, unsigned char *);
+     int (*read_config_word) (unsigned char, unsigned char, unsigned char, unsigned short *);
+     int (*read_config_dword) (unsigned char, unsigned char, unsigned char, unsigned int *);
+     int (*write_config_byte) (unsigned char, unsigned char, unsigned char, unsigned char);
+     int (*write_config_word) (unsigned char, unsigned char, unsigned char, unsigned short);
+     int (*write_config_dword) (unsigned char, unsigned char, unsigned char, unsigned int);
+ };
+ 
+ /*
+  * pointer to selected PCI access function table
+  */
+ struct pci_access *access_pci = NULL;
+ 
+ 
+ 
  /*
   * Returns the entry point for the given service, NULL on error
   */
  
  static unsigned long bios32_service(unsigned long service)
  {
!     unsigned char return_code;	/* %al */
!     unsigned long address;	/* %ebx */
!     unsigned long length;	/* %ecx */
!     unsigned long entry;	/* %edx */
! 
!     __asm__("lcall (%%edi)"
!   :	    "=a"(return_code),
! 	    "=b"(address),
! 	    "=c"(length),
! 	    "=d"(entry)
!   :	    "0"(service),
! 	    "1"(0),
! 	    "D"(&bios32_indirect));
! 
!     switch (return_code) {
!     case 0:
! 	return address + entry;
!     case 0x80:			/* Not present */
! 	printk("bios32_service(%ld) : not present\n", service);
! 	return 0;
!     default:			/* Shouldn't happen */
! 	printk("bios32_service(%ld) : returned 0x%x, mail drew@colorado.edu\n",
! 	       service, return_code);
! 	return 0;
!     }
  }
  
  static long pcibios_entry = 0;
  static struct {
!     unsigned long address;
!     unsigned short segment;
! } pci_indirect = {
! 
!     0, KERNEL_CS
! };
  
  
  extern unsigned long check_pcibios(unsigned long memory_start, unsigned long memory_end)
  {
!     unsigned long signature;
!     unsigned char present_status;
!     unsigned char major_revision;
!     unsigned char minor_revision;
!     int pack;
! 
!     if ((pcibios_entry = bios32_service(PCI_SERVICE))) {
! 	pci_indirect.address = pcibios_entry;
! 
! 	__asm__("lcall (%%edi)\n\t"
! 		"jc 1f\n\t"
! 		"xor %%ah, %%ah\n"
! 		"1:\tshl $8, %%eax\n\t"
! 		"movw %%bx, %%ax"
!       :	"=d"(signature),
! 		"=a"(pack)
!       :	"1"(PCIBIOS_PCI_BIOS_PRESENT),
! 		"D"(&pci_indirect)
!       :	"bx", "cx");
! 
! 	present_status = (pack >> 16) & 0xff;
! 	major_revision = (pack >> 8) & 0xff;
! 	minor_revision = pack & 0xff;
! 	if (present_status || (signature != PCI_SIGNATURE)) {
! 	    printk("pcibios_init : %s : BIOS32 Service Directory says PCI BIOS is present,\n"
! 		   "	but PCI_BIOS_PRESENT subfunction fails with present status of 0x%x\n"
! 		   "	and signature of 0x%08lx (%c%c%c%c).  mail drew@Colorado.EDU\n",
! 		   (signature == PCI_SIGNATURE) ? "WARNING" : "ERROR",
! 		   present_status, signature,
! 		   (char) (signature >> 0), (char) (signature >> 8),
! 		   (char) (signature >> 16), (char) (signature >> 24));
! 
! 	    if (signature != PCI_SIGNATURE)
! 		pcibios_entry = 0;
! 	}
! 	if (pcibios_entry) {
! 	    printk("pcibios_init : PCI BIOS revision %x.%02x entry at 0x%lx\n",
! 		   major_revision, minor_revision, pcibios_entry);
  	}
!     }
!     return memory_start;
  }
  
! 
! int pci_bios_find_class(unsigned int class_code, unsigned short index,
! 			unsigned char *bus, unsigned char *device_fn)
  {
!     unsigned long bx;
!     unsigned long ret;
! 
!     __asm__("lcall (%%edi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=b"(bx),
! 	    "=a"(ret)
!   :	    "1"(PCIBIOS_FIND_PCI_CLASS_CODE),
! 	    "c"(class_code),
! 	    "S"((int) index),
! 	    "D"(&pci_indirect));
!     *bus = (bx >> 8) & 0xff;
!     *device_fn = bx & 0xff;
!     return (int) (ret & 0xff00) >> 8;
! }
! 
! 
! int pci_bios_find_device(unsigned short vendor, unsigned short device_id,
!       unsigned short index, unsigned char *bus, unsigned char *device_fn)
! {
!     unsigned short bx;
!     unsigned short ret;
! 
!     __asm__("lcall (%%edi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=b"(bx),
! 	    "=a"(ret)
!   :	    "1"(PCIBIOS_FIND_PCI_DEVICE),
! 	    "c"(device_id),
! 	    "d"(vendor),
! 	    "S"((int) index),
! 	    "D"(&pci_indirect));
!     *bus = (bx >> 8) & 0xff;
!     *device_fn = bx & 0xff;
!     return (int) (ret & 0xff00) >> 8;
! }
! 
! int pci_bios_read_config_byte(unsigned char bus,
!       unsigned char device_fn, unsigned char where, unsigned char *value)
! {
!     unsigned long ret;
!     unsigned long bx = (bus << 8) | device_fn;
! 
!     __asm__("lcall (%%esi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=c"(*value),
! 	    "=a"(ret)
!   :	    "1"(PCIBIOS_READ_CONFIG_BYTE),
! 	    "b"(bx),
! 	    "D"((long) where),
! 	    "S"(&pci_indirect));
!     return (int) (ret & 0xff00) >> 8;
! }
! 
! int pci_bios_read_config_word(unsigned char bus,
!      unsigned char device_fn, unsigned char where, unsigned short *value)
! {
!     unsigned long ret;
!     unsigned long bx = (bus << 8) | device_fn;
! 
!     __asm__("lcall (%%esi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=c"(*value),
! 	    "=a"(ret)
!   :	    "1"(PCIBIOS_READ_CONFIG_WORD),
! 	    "b"(bx),
! 	    "D"((long) where),
! 	    "S"(&pci_indirect));
!     return (int) (ret & 0xff00) >> 8;
! }
! 
! int pci_bios_read_config_dword(unsigned char bus,
!        unsigned char device_fn, unsigned char where, unsigned int *value)
! {
!     unsigned long ret;
!     unsigned long bx = (bus << 8) | device_fn;
! 
!     __asm__("lcall (%%esi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=c"(*value),
! 	    "=a"(ret)
!   :	    "1"(PCIBIOS_READ_CONFIG_DWORD),
! 	    "b"(bx),
! 	    "D"((long) where),
! 	    "S"(&pci_indirect));
!     return (int) (ret & 0xff00) >> 8;
! }
! 
! int pci_bios_write_config_byte(unsigned char bus,
!        unsigned char device_fn, unsigned char where, unsigned char value)
! {
!     unsigned long ret;
!     unsigned long bx = (bus << 8) | device_fn;
! 
!     __asm__("lcall (%%esi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=a"(ret)
!   :	    "0"(PCIBIOS_WRITE_CONFIG_BYTE),
! 	    "c"(value),
! 	    "b"(bx),
! 	    "D"((long) where),
! 	    "S"(&pci_indirect));
!     return (int) (ret & 0xff00) >> 8;
! }
! 
! int pci_bios_write_config_word(unsigned char bus,
!       unsigned char device_fn, unsigned char where, unsigned short value)
! {
!     unsigned long ret;
!     unsigned long bx = (bus << 8) | device_fn;
! 
!     __asm__("lcall (%%esi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=a"(ret)
!   :	    "0"(PCIBIOS_WRITE_CONFIG_WORD),
! 	    "c"(value),
! 	    "b"(bx),
! 	    "D"((long) where),
! 	    "S"(&pci_indirect));
!     return (int) (ret & 0xff00) >> 8;
  }
  
! int pci_bios_write_config_dword(unsigned char bus,
! 	unsigned char device_fn, unsigned char where, unsigned int value)
  {
!     unsigned long ret;
!     unsigned long bx = (bus << 8) | device_fn;
  
!     __asm__("lcall (%%esi)\n\t"
! 	    "jc 1f\n\t"
! 	    "xor %%ah, %%ah\n"
! 	    "1:"
!   :	    "=a"(ret)
!   :	    "0"(PCIBIOS_WRITE_CONFIG_DWORD),
! 	    "c"(value),
! 	    "b"(bx),
! 	    "D"((long) where),
! 	    "S"(&pci_indirect));
!     return (int) (ret & 0xff00) >> 8;
  }
  
+ /*
+  * function table for BIOS32 access
+  */
+ struct pci_access pci_bios_access =
+ {
+     pci_bios_find_device,
+     pci_bios_find_class,
+     pci_bios_read_config_byte,
+     pci_bios_read_config_word,
+     pci_bios_read_config_dword,
+     pci_bios_write_config_byte,
+     pci_bios_write_config_word,
+     pci_bios_write_config_dword
+ };
+ 
  
! 
! /*
!  * Given the vendor and device ids, find the n'th instance of that device
!  * in the system.  
!  */
! int pci_direct_find_device(unsigned short vendor, unsigned short device_id,
! 			   unsigned short index, unsigned char *bus,
! 			   unsigned char *devfn)
! {
!     unsigned int curr = 0;
!     struct pci_dev *dev;
! 
!     for (dev = pci_devices; dev; dev = dev->next) {
! 	if (dev->vendor == vendor && dev->device == device_id) {
! 	    if (curr == index) {
! 		*devfn = dev->devfn;
! 		*bus = dev->bus->number;
! 		return PCIBIOS_SUCCESSFUL;
! 	    }
! 	    ++curr;
! 	}
!     }
!     return PCIBIOS_DEVICE_NOT_FOUND;
! }
! 
! 
! /*
!  * Given the class, find the n'th instance of that device
!  * in the system.
!  */
! int pci_direct_find_class(unsigned int class_code, unsigned short index,
! 			  unsigned char *bus, unsigned char *devfn)
  {
!     unsigned int curr = 0;
!     struct pci_dev *dev;
  
!     for (dev = pci_devices; dev; dev = dev->next) {
! 	if (dev->class == class_code) {
! 	    if (curr == index) {
! 		*devfn = dev->devfn;
! 		*bus = dev->bus->number;
! 		return PCIBIOS_SUCCESSFUL;
! 	    }
! 	    ++curr;
! 	}
!     }
!     return PCIBIOS_DEVICE_NOT_FOUND;
! }
! 
! /*
!  * Functions for accessing PCI configuration space with type 1 accesses
!  */
! #define CONFIG_CMD(bus, device_fn, where)   (0x80000000 | (bus << 16) | (device_fn << 8) | (where & ~3))
! 
! int pci_conf1_read_config_byte(unsigned char bus, unsigned char device_fn,
! 			       unsigned char where, unsigned char *value)
! {
!     outl(CONFIG_CMD(bus, device_fn, where), 0xCF8);
!     switch (where & 3) {
!     case 0:
! 	*value = inb(0xCFC);
! 	break;
!     case 1:
! 	*value = inb(0xCFD);
! 	break;
!     case 2:
! 	*value = inb(0xCFE);
! 	break;
!     case 3:
! 	*value = inb(0xCFF);
! 	break;
!     }
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf1_read_config_word(unsigned char bus,
!      unsigned char device_fn, unsigned char where, unsigned short *value)
! {
!     outl(CONFIG_CMD(bus, device_fn, where), 0xCF8);
!     if (where & 2)
! 	*value = inw(0xCFE);
!     else
! 	*value = inw(0xCFC);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf1_read_config_dword(unsigned char bus, unsigned char device_fn,
! 				unsigned char where, unsigned int *value)
! {
!     outl(CONFIG_CMD(bus, device_fn, where), 0xCF8);
!     *value = inl(0xCFC);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf1_write_config_byte(unsigned char bus, unsigned char device_fn,
! 				unsigned char where, unsigned char value)
! {
!     outl(CONFIG_CMD(bus, device_fn, where), 0xCF8);
!     outb(value, 0xCFC);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf1_write_config_word(unsigned char bus, unsigned char device_fn,
! 				unsigned char where, unsigned short value)
! {
!     outl(CONFIG_CMD(bus, device_fn, where), 0xCF8);
!     outw(value, 0xCFC);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf1_write_config_dword(unsigned char bus, unsigned char device_fn,
! 				 unsigned char where, unsigned int value)
! {
!     outl(CONFIG_CMD(bus, device_fn, where), 0xCF8);
!     outl(value, 0xCFC);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! #undef CONFIG_CMD
! 
! /*
!  * functiontable for type 1
!  */
! struct pci_access pci_direct_conf1 =
! {
!     pci_direct_find_device,
!     pci_direct_find_class,
!     pci_conf1_read_config_byte,
!     pci_conf1_read_config_word,
!     pci_conf1_read_config_dword,
!     pci_conf1_write_config_byte,
!     pci_conf1_write_config_word,
!     pci_conf1_write_config_dword
! };
! 
! /*
!  * Functions for accessing PCI configuration space with type 2 accesses
!  */
! #define IOADDR(devfn, where)   ((0xC000 | ((devfn & 0x78) << 5)) + where)
! #define FUNC(devfn)            (((devfn & 7) << 1) | 0xf0)
! 
! int pci_conf2_read_config_byte(unsigned char bus, unsigned char device_fn,
! 			       unsigned char where, unsigned char *value)
! {
!     if (device_fn & 0x80)
! 	return PCIBIOS_DEVICE_NOT_FOUND;
!     outb(FUNC(device_fn), 0xCF8);
!     outb(bus, 0xCFA);
!     *value = inb(IOADDR(device_fn, where));
!     outb(0, 0xCF8);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf2_read_config_word(unsigned char bus, unsigned char device_fn,
! 			       unsigned char where, unsigned short *value)
! {
!     if (device_fn & 0x80)
! 	return PCIBIOS_DEVICE_NOT_FOUND;
!     outb(FUNC(device_fn), 0xCF8);
!     outb(bus, 0xCFA);
!     *value = inw(IOADDR(device_fn, where));
!     outb(0, 0xCF8);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf2_read_config_dword(unsigned char bus, unsigned char device_fn,
! 				unsigned char where, unsigned int *value)
! {
!     if (device_fn & 0x80)
! 	return PCIBIOS_DEVICE_NOT_FOUND;
!     outb(FUNC(device_fn), 0xCF8);
!     outb(bus, 0xCFA);
!     *value = inl(IOADDR(device_fn, where));
!     outb(0, 0xCF8);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf2_write_config_byte(unsigned char bus, unsigned char device_fn,
! 				unsigned char where, unsigned char value)
! {
!     outb(FUNC(device_fn), 0xCF8);
!     outb(bus, 0xCFA);
!     outb(value, IOADDR(device_fn, where));
!     outb(0, 0xCF8);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf2_write_config_word(unsigned char bus, unsigned char device_fn,
! 				unsigned char where, unsigned short value)
! {
!     outb(FUNC(device_fn), 0xCF8);
!     outb(bus, 0xCFA);
!     outw(value, IOADDR(device_fn, where));
!     outb(0, 0xCF8);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! int pci_conf2_write_config_dword(unsigned char bus, unsigned char device_fn,
! 				 unsigned char where, unsigned int value)
! {
!     outb(FUNC(device_fn), 0xCF8);
!     outb(bus, 0xCFA);
!     outl(value, IOADDR(device_fn, where));
!     outb(0, 0xCF8);
!     return PCIBIOS_SUCCESSFUL;
! }
! 
! #undef IOADDR
! #undef FUNC
! 
! /*
!  * functiontable for type 2
!  */
! struct pci_access pci_direct_conf2 =
! {
!     pci_direct_find_device,
!     pci_direct_find_class,
!     pci_conf2_read_config_byte,
!     pci_conf2_read_config_word,
!     pci_conf2_read_config_dword,
!     pci_conf2_write_config_byte,
!     pci_conf2_write_config_word,
!     pci_conf2_write_config_dword
! };
! 
! #endif
! 
! struct pci_access *check_direct_pci(void)
! {
!     unsigned int tmp;
! 
!     /*
!      * check if configuration type 1 works
!      */
!     outb(0x01, 0xCFB);
!     tmp = inl(0xCF8);
!     outl(0x80000000, 0xCF8);
!     if (inl(0xCF8) == 0x80000000) {
! 	outl(tmp, 0xCF8);
! 	printk("pcibios_init: Using configuration type 1\n");
! 	return &pci_direct_conf1;
!     }
!     outl(tmp, 0xCF8);
! 
!     /*
!      * check if configuration type 2 works
!      */
!     outb(0x00, 0xCFB);
!     outb(0x00, 0xCF8);
!     outb(0x00, 0xCFA);
!     if (inb(0xCF8) == 0x00 && inb(0xCFC) == 0x00) {
! 	printk("pcibios_init: Using configuration type 2\n");
! 	return &pci_direct_conf2;
!     }
!     printk("pcibios_init: Not supported chipset for direct PCI access !\n");
!     return NULL;
! }
! 
! 
! /*
!  * access defined pcibios functions via
!  * the function table
!  */
! 
! int pcibios_present(void)
! {
!     return access_pci ? 1 : 0;
! }
! 
! int pcibios_find_class(unsigned int class_code, unsigned short index,
! 		       unsigned char *bus, unsigned char *device_fn)
! {
!     if (access_pci && access_pci->find_class)
! 	return access_pci->find_class(class_code, index, bus, device_fn);
! 
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
! }
! 
! int pcibios_find_device(unsigned short vendor, unsigned short device_id,
!       unsigned short index, unsigned char *bus, unsigned char *device_fn)
! {
!     if (access_pci && access_pci->find_device)
! 	return access_pci->find_device(vendor, device_id, index, bus, device_fn);
! 
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
  }
  
  int pcibios_read_config_byte(unsigned char bus,
!       unsigned char device_fn, unsigned char where, unsigned char *value)
  {
!     if (access_pci && access_pci->read_config_byte)
! 	return access_pci->read_config_byte(bus, device_fn, where, value);
  
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
  }
  
! int pcibios_read_config_word(unsigned char bus,
!      unsigned char device_fn, unsigned char where, unsigned short *value)
  {
!     if (access_pci && access_pci->read_config_word)
! 	return access_pci->read_config_word(bus, device_fn, where, value);
  
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
  }
  
! int pcibios_read_config_dword(unsigned char bus,
!        unsigned char device_fn, unsigned char where, unsigned int *value)
  {
!     if (access_pci && access_pci->read_config_dword)
! 	return access_pci->read_config_dword(bus, device_fn, where, value);
  
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
  }
  
! int pcibios_write_config_byte(unsigned char bus,
!        unsigned char device_fn, unsigned char where, unsigned char value)
  {
!     if (access_pci && access_pci->write_config_byte)
! 	return access_pci->write_config_byte(bus, device_fn, where, value);
  
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
  }
  
! int pcibios_write_config_word(unsigned char bus,
!       unsigned char device_fn, unsigned char where, unsigned short value)
  {
!     if (access_pci && access_pci->write_config_word)
! 	return access_pci->write_config_word(bus, device_fn, where, value);
  
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
  }
  
! int pcibios_write_config_dword(unsigned char bus,
  	unsigned char device_fn, unsigned char where, unsigned int value)
  {
!     if (access_pci && access_pci->write_config_dword)
! 	return access_pci->write_config_dword(bus, device_fn, where, value);
  
!     return PCIBIOS_FUNC_NOT_SUPPORTED;
  }
  
! const char *pcibios_strerror(int error)
  {
!     static char buf[80];
  
!     switch (error) {
!     case PCIBIOS_SUCCESSFUL:
! 	return "SUCCESSFUL";
  
!     case PCIBIOS_FUNC_NOT_SUPPORTED:
! 	return "FUNC_NOT_SUPPORTED";
  
!     case PCIBIOS_BAD_VENDOR_ID:
! 	return "SUCCESSFUL";
  
!     case PCIBIOS_DEVICE_NOT_FOUND:
! 	return "DEVICE_NOT_FOUND";
  
!     case PCIBIOS_BAD_REGISTER_NUMBER:
! 	return "BAD_REGISTER_NUMBER";
  
!     case PCIBIOS_SET_FAILED:
! 	return "SET_FAILED";
  
!     case PCIBIOS_BUFFER_TOO_SMALL:
! 	return "BUFFER_TOO_SMALL";
  
!     default:
! 	sprintf(buf, "UNKNOWN RETURN 0x%x", error);
! 	return buf;
!     }
  }
  
  
  unsigned long pcibios_fixup(unsigned long mem_start, unsigned long mem_end)
  {
!     return mem_start;
  }
  
  
  unsigned long pcibios_init(unsigned long memory_start, unsigned long memory_end)
  {
!     union bios32 *check;
!     unsigned char sum;
!     int i, length;
! 
!     /*
!      * Follow the standard procedure for locating the BIOS32 Service
!      * directory by scanning the permissible address range from
!      * 0xe0000 through 0xfffff for a valid BIOS32 structure.
!      *
!      */
! 
!     for (check = (union bios32 *) 0xe0000; check <= (union bios32 *) 0xffff0; ++check) {
! 	if (check->fields.signature != BIOS32_SIGNATURE)
! 	    continue;
! 	length = check->fields.length * 16;
! 	if (!length)
! 	    continue;
! 	sum = 0;
! 	for (i = 0; i < length; ++i)
! 	    sum += check->chars[i];
! 	if (sum != 0)
! 	    continue;
! 	if (check->fields.revision != 0) {
! 	    printk("pcibios_init : unsupported revision %d at 0x%p, mail drew@colorado.edu\n",
! 		   check->fields.revision, check);
! 	    continue;
  	}
! 	printk("pcibios_init : BIOS32 Service Directory structure at 0x%p\n", check);
! 	if (!bios32_entry) {
! 	    if (check->fields.entry >= 0x100000) {
! 		printk("pcibios_init: entry in high memory, trying direct PCI access\n");
! 		access_pci = check_direct_pci();
! 	    } else {
! 		bios32_indirect.address = bios32_entry = check->fields.entry;
! 		printk("pcibios_init : BIOS32 Service Directory entry at 0x%lx\n", bios32_entry);
! 		access_pci = &pci_bios_access;
! 	    }
  	}
+     }
+ #ifdef CONFIG_PCI
+     if (bios32_entry) {
+ 	memory_start = check_pcibios(memory_start, memory_end);
+     }
  #endif
!     return memory_start;
  }
*** linux-2.0.28/drivers/block/ide-cd.c	Fri Sep 20 07:00:34 1996
--- KERNEL/drivers/block/ide-cd.c	Thu Jul 31 12:02:58 1997
***************
*** 707,713 ****
  			} else if (sense_key == UNIT_ATTENTION) {
  				/* Check for media change. */
  				cdrom_saw_media_change (drive);
! 				printk ("%s: media changed\n", drive->name);
  			} else {
  				/* Otherwise, print an error. */
  				ide_dump_status (drive, "packet command error",
--- 707,713 ----
  			} else if (sense_key == UNIT_ATTENTION) {
  				/* Check for media change. */
  				cdrom_saw_media_change (drive);
! 				printk (KERN_DEBUG "%s: media changed\n", drive->name);
  			} else {
  				/* Otherwise, print an error. */
  				ide_dump_status (drive, "packet command error",
